#     							-*- Autoconf -*-
# Author: Nicolas Pierron <nicolas.b.pierron@gmail.com>
#

# XT_CHECK_PROLOG_TOOLS
# ---------------------
AC_DEFUN([XT_CHECK_PROLOG_TOOLS], [
  AC_ARG_WITH([prolog-tools],
    [AS_HELP_STRING(
      [--with-prolog-tools=DIR],
      [use Prolog tools at DIR @<:@find with pkg-config@:>@]
    )],
    [PROLOG_TOOLS=$withval])

  if test "x$PROLOG_TOOLS" == x; then
    XT_CHECK_PACKAGE([PROLOG_TOOLS],[prolog-tools])
  fi

  AC_MSG_CHECKING([for parse-prolog at $PROLOG_TOOLS/bin/parse-prolog])
  test -x "$PROLOG_TOOLS/bin/parse-prolog"
  if test $? -eq 0; then
    AC_MSG_RESULT([yes])
  else
    AC_MSG_RESULT([no])
    AC_MSG_ERROR([cannot find parse-prolog. Is prolog-tools installed correctly?])
  fi

  AC_MSG_CHECKING([for pp-prolog at $PROLOG_TOOLS/bin/pp-prolog])
  test -x "$PROLOG_TOOLS/bin/pp-prolog"
  if test $? -eq 0; then
    AC_MSG_RESULT([yes])
  else
    AC_MSG_RESULT([no])
    AC_MSG_ERROR([cannot find pp-prolog. Is prolog-tools installed correctly?])
  fi
])
