#     							-*- Autoconf -*-
# Author: Nicolas Pierron <nicolas.b.pierron@gmail.com>
#

# LT_CHECK_SWIPL
# --------------
AC_DEFUN([LT_CHECK_SWIPL], [
  # pl is the name of the SWI-Prolog compiler.
  AC_ARG_WITH([swi-prolog],
    [AS_HELP_STRING(
      [--with-swi-prolog=PATH],
      [custom PATH to SWI-Prolog @<:@find in $PATH@:>@]
    )],
    [SWIPL=$withval])

  if test "x$SWIPL" == "x"; then
    AC_PATH_PROG([SWIPL], [pl])
  fi

  AC_MSG_CHECKING([for SWI-Prolog])
  if test -z "$SWIPL" ; then
    AC_MSG_RESULT([no])
    AC_MSG_ERROR([cannot find "pl". Use the SWIPL variable or the PATH variable.])
  fi
  AC_MSG_RESULT([yes])

  AC_SUBST([SWIPL])
])
