:- consult('program_checker.pl').

extract_output(Args, Out) :-
        append(_, ['-o', OutName|_], Args),
        open(OutName, write, Out),
        !.

extract_output(_, Out) :-
        current_output(Out).

extract_options(Args, IN, OUT, CONST) :-
        append(_, ['-i', IN|_], Args),
        extract_output(Args, OUT),
        append(_, ['-c', CONST|_], Args).

eval :-
        current_prolog_flag(argv, Args),
        extract_options(Args, In, Out, Const),
        check_program(In,Const,_,Out).

main :-
        catch(eval, E, (print_message(error, E), fail)),
        halt.
main :-
        halt(1).
