/***************************************************************************
* Java access graph library 
***************************************************************************/

%--------------------------------------------------------------------------
% Test existing path (only with inherits or contains relations)
%
% pathExist(+Source_node,+Destination_node)
%--------------------------------------------------------------------------
pathExist(Node,Node).
pathExist(SrcNode,DstNode) :-
  (convInherits(IntermedNode,SrcNode);convContains(SrcNode,IntermedNode)),
  pathExist(IntermedNode,DstNode).


%--------------------------------------------------------------------------
% Get path between two nodes (only with inherits or contains relations)
%
% path(+Source_node,+Destination_node,-Path)
%--------------------------------------------------------------------------
path(SrcNode,DstNode,Path) :-
  intermedPath(SrcNode,DstNode,[SrcNode],ReversePath),
  reverse(ReversePath,Path).

intermedPath(SrcNode,DstNode,PNode,[DstNode|PNode]) :-
  (convInherits(DstNode,SrcNode);convContains(SrcNode,DstNode)).

intermedPath(SrcNode,DstNode,PNode,Path) :-
  (convInherits(IntermedNode,SrcNode);convContains(SrcNode,IntermedNode)),
  intermedPath(IntermedNode,DstNode,[IntermedNode|PNode],Path).

%--------------------------------------------------------------------------
% Test inherits links between two nodes
%
% pathExist(+Source_node,+Destination_node)
%--------------------------------------------------------------------------
inheritsLink(Node,Node).
inheritsLink(SrcNode,DstNode) :-
  convInherits(SrcNode,IntermedNode),
  inheritsLink(DstNode,IntermedNode).

