:- consult('violations_correction.pl').

extract_output(Args, Out) :-
        append(_, ['-o', OutName|_], Args),
        open(OutName, write, Out),
        !.

extract_output(_, Out) :-
        current_output(Out).

extract_options(Args, IN, OUT, CONST, VIOL) :-
        append(_, ['-i', IN|_], Args),
        extract_output(Args, OUT),
        append(_, ['-c', CONST|_], Args),
        append(_, ['-v', VIOL|_], Args).

correct :-
        current_prolog_flag(argv, Args),
        extract_options(Args, In, Out, Const, Viol),
        violations_correction(In,Const,Viol,Out).

main :-
        catch(correct, E, (print_message(error, E), fail)),
        halt.
main :-
        halt(1).
