#!/bin/sh

if test -z "$VERBOSE"; then
  VERBOSE=0
fi

if test -z "$KEEP"; then
  KEEP=0
fi

if test "$VERBOSE" = "0"; then
  exec >/dev/null 2>&1
else
  set -x
fi

# use xtc to find a tool
xtc_tool(){
  local tool_name=$1
  xtc query -t "$tool_name" |\
      sed -e 's/^.*: //'
}

trm(){
  test -e "$1" && rm -f "$1" || true
}

clean(){
  trm "$1.tmp.1"
  trm "$1.tmp.2"
  trm "$1.java.res"
}

check(){
  local res=$?
  if test $res -ne 0; then
    if test "$KEEP" = "0"; then
      clean "$1"
    fi;
    exit $res
  fi
}

name="$(basename $0)"
clean "$name"

$(xtc_tool "java-graph")\
    -i "$SRCDIR/$name.java"\
    -o "$name.tmp.1"\
    --verbose "$VERBOSE"\
    --keep "$KEEP"
check "$name"

sed "s/'[a-z]_[0-9]*'/NODE/g" "$name.tmp.1" > "$name.tmp.2"
check "$name"

$(xtc_tool "pp-prolog")\
    -i "$name.tmp.2"\
    -o "$name.java.res"\
    --verbose "$VERBOSE"\
    --keep "$KEEP"
check "$name"

diff -u "$name.java.res" "$SRCDIR/$name.java.ref"
check "$name"

if test "$KEEP" = "0"; then
  clean "$name"
fi
