#!/bin/sh

if test -z "$VERBOSE"; then
  VERBOSE=0
fi

if test -z "$KEEP"; then
  KEEP=0
fi

if test "$VERBOSE" = "0"; then
  exec >/dev/null 2>&1
else
  set -x
fi

# use xtc to find a tool
xtc_tool(){
  local tool_name=$1
  xtc query -t "$tool_name" |\
      sed -e 's/^.*: //'
}

clean(){
  test -e "$1.res.java" &&\
      rm -f "$1.res.java"
}

name="$(basename $0)"
clean "$name"
$(xtc_tool "lutin")\
    -i "$SRCDIR/$name.java"\
    --fold -c "$SRCDIR/$name.pl"\
    --java -o "$name.res.java"\
    --verbose "$VERBOSE"\
    --keep "$KEEP"

diff "$name.res.java" "$SRCDIR/$name.ref.java"
