// Editor.java 
package edit;
import java.util.*;

abstract class Graphic {
  abstract public void draw();
}

class Line extends Graphic{
  public Line() {}
  public void draw() { 
    System.out.println("Line");}
}

class Picture {
   private ArrayList<Graphic> elements;
   public Picture() {
     elements = new ArrayList<Graphic>();
   	 elements.add(new Line());
   	 elements.add(new Line());
   }
   ArrayList<Graphic> getElements() {
      return elements;
   }
}
   
public class Editor {
  private ArrayList<Graphic> theGraphics;
  private ArrayList<Picture> thePictures;
  
  public Editor() {
    theGraphics = new ArrayList<Graphic>();
    thePictures = new ArrayList<Picture>();
  }
  
  public void display () {
    for (Graphic g : theGraphics)
      g.draw();
    for (Picture p : thePictures) {
      System.out.println("Picture");
      for (Graphic e : p.getElements())
        e.draw();
    }
  }
  
  public void addElement(int kind) {
    switch (kind) {
      case 0:  theGraphics.add(new Line());
               break;
      case 1:  thePictures.add(new Picture());
               break;
    }
  }
  
  public static int addMenu() {
    System.out.println("Choose the kind of element to add");
    System.out.println("0: Line");
    System.out.println("1: Picture");
    Scanner in = new Scanner(System.in);
    return in.nextInt();
  }
  
  public static void main(String[] args) {
  	Editor theEditor = new Editor();
  	
  	theEditor.addElement(addMenu());
  	theEditor.addElement(addMenu());
  	
  	theEditor.display();
  }
}
