// Editor.java
package edit;

import java.util.*;
 
abstract class Graphic {
  private static ArrayList<Graphic> prototypes;
  abstract public void draw();
  abstract public Graphic create();
  abstract public String getClassName();
  public static ArrayList<Graphic> getPrototypes() { return prototypes; }
  static   { prototypes = new ArrayList<Graphic>();
             prototypes.add(0, new Line());
             prototypes.add(1, new Picture());
           }
}

class Line extends Graphic {
  public Line()                 {}
  public void draw()            { System.out.println("Line"); }
  public Graphic create()       { return new Line(); }
  public String getClassName()  { return "Line"; }
}

class Picture extends Graphic {
  private ArrayList<Graphic> elements;
  public Picture()                   { elements = new ArrayList<Graphic>();
  	                                   elements.add(new Line());
   	                                   elements.add(new Line());
                                     }
  ArrayList<Graphic> getElements()   { return elements; }
  public Graphic create()            { return new Picture(); }
  public String getClassName()       { return "Picture"; }
  public void draw()                 { System.out.println("Picture");
                                       for (Graphic e : elements)
                                         e.draw();
                                     }    
}
   
public class Editor {
  private ArrayList<Graphic> theGraphics;
  
  public Editor()             { theGraphics = new ArrayList<Graphic>(); }
  public void display ()      { for (Graphic g : theGraphics)
                                  g.draw();
                              }
  void addElement(int kind)   { theGraphics.add(Graphic.getPrototypes().get(kind).create()); }
  public static int addMenu() { System.out.println("Choose the kind of element to add");
                                int i = 0;
                                for (Graphic g : Graphic.getPrototypes())
                                  System.out.println(i++ + " " + g.getClassName());
                                Scanner in = new Scanner(System.in);
                                return in.nextInt();
                              }
  
  public static void main(String[] args)
                              { Editor theEditor = new Editor();
  	                            theEditor.addElement(addMenu());
  	                            theEditor.addElement(addMenu());
  	                            theEditor.display();
                              }
}
