#!/bin/sh

if test -n "$VERBOSE"; then
  set -x
else
  exec >/dev/null 2>&1
fi

# use xtc to find a tool
xtc_tool(){
  local tool_name=$1
  xtc query -t "$tool_name" |\
      sed -e 's/^.*: //'
}

clean(){
  local name=$1;
  test -e "${name}-result.pl" &&\
      rm -f "${name}-result.pl"
}

name="$(basename $0)"
clean "$name"
$(xtc_tool "violations_correction")\
    -i "$SRCDIR/$name-graph.pl"\
    -c "$SRCDIR/$name-constraints.pl"\
    -v "$SRCDIR/$name-violations.pl"\
    -o "$name-result.pl"

diff "$name-result.pl" "$SRCDIR/$name-corrections.pl"
ret=$?

if test "x$KEEP" = "x"; then
  clean "$name"
fi
exit $ret;
